#!/bin/bash

src_repo_username='anthill3'
src_repo_password='anthill3'
src_repo_repositoryUrl='https://svn.urbancode.com/urbancode/demo'
src_projectTrunkPath='trunk/Anthill-Example'
src_dirOffset='.'
revision=1
doExport='false'
cleanWorkspace='false'
date=''  #sample date could be 1234567890000
depth='infinity'
# TODO branch, tag, tagsPath, branchesPath

if [[ -n $date ]]; then
  # change from milliseconds to seconds, then calculate time from now and use date to get svn format
  date=$(( $date / 1000 ));
  date=$(date -u  --date "$[$(date +%s)-($date)] seconds ago" "+%F %T +0000");
fi

if [[ -n cleanWorkspace ]]; then
  # remove src_dirOffset directory recursively (force)
  echo "TODO clean workspace";# rm -rf "$src_dirOffset"
fi

SVN_ARGS=("--non-interactive" "--no-auth-cache")

if [[ depth = 'empty' ]]; then
  SVN_ARGS[${#SVN_ARGS[@]}]="--depth";
  SVN_ARGS[${#SVN_ARGS[@]}]="empty";
elif [[ depth = 'files' ]]; then
  SVN_ARGS[${#SVN_ARGS[@]}]="--depth";
  SVN_ARGS[${#SVN_ARGS[@]}]="files";
elif [[ depth = 'immediates' ]]; then
  SVN_ARGS[${#SVN_ARGS[@]}]="--depth";
  SVN_ARGS[${#SVN_ARGS[@]}]="immediates";
fi

if [[ doExport = 'true' ]]; then
  SVN_ARGS[${#SVN_ARGS[@]}]="export";
  SVN_ARGS[${#SVN_ARGS[@]}]="--force";
else
  SVN_ARGS[${#SVN_ARGS[@]}]="checkout";
fi

if [[ -n $src_repo_username ]]; then
  SVN_ARGS[${#SVN_ARGS[@]}]="--username";
  SVN_ARGS[${#SVN_ARGS[@]}]="$src_repo_username";
fi

if [[ -n $src_repo_password ]]; then
  SVN_ARGS[${#SVN_ARGS[@]}]="--password";
  SVN_ARGS[${#SVN_ARGS[@]}]="$src_repo_password";
fi

if [[ -n $date ]]; then
  SVN_ARGS[${#SVN_ARGS[@]}]="--revision";
  SVN_ARGS[${#SVN_ARGS[@]}]="{$date}";
elif [[ -n $revision ]]; then
  SVN_ARGS[${#SVN_ARGS[@]}]="--revision";
  SVN_ARGS[${#SVN_ARGS[@]}]="$revision";
fi

SVN_ARGS[${#SVN_ARGS[@]}]="${src_repo_repositoryUrl}/${src_projectTrunkPath}";
SVN_ARGS[${#SVN_ARGS[@]}]="${scr_dirOffset:-.}";

echo "svn ${SVN_ARGS[@]}"
svn "${SVN_ARGS[@]}"
# script exit code is based upon last statement in script
